ENEMY = Core.class()

function ENEMY:init(xworld, xobjpath, xobjname, xparams, xBIT, xCOLBIT)
	-- params
	local params = xparams or {}
	xposx = params.posx or 0
	xposy = params.posy or 0
	xposz = params.posz or 0
	xrotx = params.rotx or 0
	xroty = params.roty or 0
	xrotz = params.rotz or 0
	xmass = params.mass or 1
	xgravity = params.gravity
	-- the obj
	self.obj = loadObj(xobjpath, xobjname)
	local minx, miny, minz = self.obj.min[1], self.obj.min[2], self.obj.min[3] -- can be negative numbers
	local maxx, maxy, maxz = self.obj.max[1], self.obj.max[2], self.obj.max[3]
	local width, height, length = maxx - minx, maxy - miny, maxz - minz
--	print("enemy", self.obj, width, height, length)
	self.obj.shape1 = r3d.SphereShape.new(height / 2)
	-- the obj viewport
	self.obj.view = Viewport.new()
	self.obj.view:setContent(self.obj)
	local matrix = self.obj.view:getMatrix()
	matrix:setPosition(xposx, xposy, xposz)
	matrix:setRotationX(xrotx)
	matrix:setRotationY(xroty)
	matrix:setRotationZ(xrotz)
	self.obj.view:setMatrix(matrix)
	-- body
	self.obj.body = xworld:createBody(self.obj.view:getMatrix())
	self.obj.body:setType(r3d.Body.DYNAMIC_BODY)
	if xgravity then self.obj.body:enableGravity(xgravity) else self.obj.body:enableGravity(true) end
	self.obj.body:setAngularDamping(0.5)
	self.obj.body:setLinearDamping(0.5)
	-- fixtures
	local m1 = Matrix.new()
	m1:setPosition(0, 0, 0)
	local fixture1 = self.obj.body:createFixture(self.obj.shape1, m1, xmass) -- shape, transform, mass
	fixture1:setCollisionCategoryBits(xBIT)
	fixture1:setCollideWithMaskBits(xCOLBIT)
	-- material
	local mat = self.obj.body:getMaterial() -- default: bounciness = 0.5, frictionCoefficient = 0.3, rollingResistance = 0
	mat.bounciness = 0.1
	mat.frictionCoefficient = 0.8
	mat.rollingResistance = 0.8 -- 0 = no resistance, 1 = max resistance
	self.obj.body:setMaterial(mat)
	-- table
	xworld.enemies[self.obj] = {body=self.obj.body, isdirty=false}
end

function ENEMY:get()
	return self.obj, self.obj.body
end
