MISSILE = Core.class()

function MISSILE:init(xworld, xfolderpath, xobjname, xparams, xBIT, xCOLBIT)
	-- params
	local params = xparams or {}
	xposx = params.posx or 0
	xposy = params.posy or 0
	xposz = params.posz or 0
	xrotx = params.rotx or 0
	xroty = params.roty or 0
	xrotz = params.rotz or 0
	xmass = params.mass or 10
	xgravity = params.gravity
	-- the .obj
	self.obj = loadObj(xfolderpath, xobjname)
	local minx, miny, minz = self.obj.min[1], self.obj.min[2], self.obj.min[3] -- can be negative numbers
	local maxx, maxy, maxz = self.obj.max[1], self.obj.max[2], self.obj.max[3]
	local width, height, length = maxx - minx, maxy - miny, maxz - minz
--	print("self.obj", width, height, length)
	self.obj.shape1 = r3d.BoxShape.new(width / 2, height / 2, length / 2)
	-- the obj viewport
	self.obj.view = Viewport.new()
	self.obj.view:setContent(self.obj)
	local matrix = self.obj.view:getMatrix()
	matrix:setPosition(xposx, xposy, xposz)
	matrix:setRotationX(xrotx)
	matrix:setRotationY(xroty)
	matrix:setRotationZ(xrotz)
	self.obj.view:setMatrix(matrix)
	-- the body
	self.obj.body = xworld:createBody(self.obj.view:getMatrix())
	self.obj.body:setType(r3d.Body.DYNAMIC_BODY)
	if xgravity then self.obj.body:enableGravity(xgravity) else self.obj.body:enableGravity(true) end
	local fixture1 = self.obj.body:createFixture(self.obj.shape1, nil, xmass) -- shape, transform, mass
	fixture1:setCollisionCategoryBits(xBIT)
	fixture1:setCollideWithMaskBits(xCOLBIT)
	-- material
	local mat = self.obj.body:getMaterial() -- default: bounciness = 0.5, frictionCoefficient = 0.3, rollingResistance = 0
	mat.bounciness = 0
	mat.frictionCoefficient = 0
	mat.rollingResistance = 0 -- 0 = no resistance, 1 = max resistance
	self.obj.body:setMaterial(mat)
	-- table
	xworld.missiles[self.obj] = {body=self.obj.body, isdirty=false}
end

function MISSILE:get()
	return self.obj
end
